(function ($) {
  if (/(iPhone|iPad|iPod)/.test(navigator.userAgent)) {
    document.__iosFullscreenEnabled = true;
    document.__iosFullscreenElement = null;
  }

  var scrollpos = 0;
  var viewportMeta;
  var viewportContent;

  // フルスクリーンに切り替え（IOS版）  
  Element.prototype.__iosRequestFullscreen = function() {
    // スマホブラウザ上のズーム設定を無効にする
    disableZoom();

    // CSSで対象要素をブラウザ全体に広げる
    $(this).css({ 'position': 'fixed', 'z-index': 2147483647, 'width': '100%', 'height': '100%' });
    scrollpos = $(window).scrollTop();
    $('body').css({ 'position': 'fixed'});

    // フルスクリーン表示中の要素を指定して切り替え終了
    fullscreenChange(this);
  };

  // フルスクリーンの解除（IOS版）
  Document.prototype.__iosCancelFullScreen = function() {
    // フルスクリーン表示中の要素を取得
    var target = document.__iosFullscreenElement;
    if (target === null) {
      return;
    }

    // CSSで追加した設定を元に戻す
    $(target).css({ 'position': '', 'z-index': '', 'width': '', 'height': '' });
    $('body').css({ 'position': ''});
    window.scrollTo( 0 , scrollpos );

    // スマホブラウザ上のズーム設定を元に戻す
    restoreZoom();

    // フルスクリーン表示中の要素をnullに設定して切り替え終了
    fullscreenChange(null);
  };

  // フルスクリーンの切り替え終了処理
  function fullscreenChange(elem) {
    document.__iosFullscreenElement = elem;
    // リサイズとIOS版のFullscreenChangeイベントを発火させる
    dispatchEvent(window, 'resize');
    dispatchEvent(document, '__iosfullscreenchange');
  }

  // イベントを作成してディスパッチする
  function dispatchEvent(obj, type) {
    var event = document.createEvent('Event');
    event.initEvent(type, true, true);
    obj.dispatchEvent(event);
  }

  // スマホブラウザ上のズーム設定を元に戻す
  function restoreZoom() {
    if (viewportMeta){
      viewportMeta.setAttribute( 'content', viewportContent );
    }
  }

  // スマホブラウザ上のズーム設定を無効にする
  function disableZoom() {
    meta = viewportMeta || document.querySelector( "meta[name=viewport]" );
    if (meta) {
      viewportContent = meta.getAttribute( "content" );
    } else {
      meta = document.createElement('meta');
      meta.setAttribute('name', 'viewport');
      document.getElementsByTagName('head')[0].appendChild(meta);
      viewportContent = '';
    }
    var contentBase = viewportContent || 'width=device-width, initial-scale=1';
    meta.setAttribute('content', contentBase + ', maximum-scale=1');
    viewportMeta = meta;
  }
})(jQuery);
