/**
 * media-uploader.js
 * Version    : 1.0.0
 * Author     : Green Sheep
 * Created    : May 8, 2017
 * Modified   :
 * License    : GPLv2 or later
 * License URI: http://www.gnu.org/licenses/gpl-2.0.html
 */
(function ($) {

	var custom_uploader;

	$("input:button[name^=media-select]").click(function(e) {

		e.preventDefault();

		var targetName = e.target.name.replace("media-select-", "");

		custom_uploader = wp.media({
			title: "画像を選択",
			library: {
				type: "image"
			},
			button: {
				text: "画像を決定"
			},
			multiple: false
		});

		custom_uploader.on("select", function() {

			var images = custom_uploader.state().get("selection");

			images.each(function(file) {

				$("input[name=" + targetName + "]").val("");
				$("#media-" + targetName).empty();

				$("input[name=" + targetName + "]").val(file.id);

				$("#media-" + targetName).append('<img src="' + file.attributes.sizes.full.url+'" />');
			});
		});

		custom_uploader.open();
	});

	// 選択した画像をクリアする
	$("input:button[name^=media-clear]").click(function(e) {
		// クリア対象の名前を取得する
		var targetName = e.target.name.replace("media-clear-", "");
		// クリア
		$("input[name=" + targetName + "]").val("");
		$("#media-" + targetName).empty();
		// $("#media-" + targetName).removeClass("wmm-marker-image");
	});
})(jQuery);